unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine,
  VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeCanvas;

type
  TForm1 = class(TForm)
    chrtContribs: TChart;
    srsCurrContribAlloc: TPieSeries;
    srsCurrBalance: TPieSeries;
    srsRetireBalance: TPieSeries;

    procedure srsCurrContribAllocBeforeDrawValues(Sender: TObject);

  private
    { Private declarations }
    function GetChartHMargin(aChart: TChart): integer;
    function GetChartVMargin(aChart: TChart): integer;
    procedure DrawPieSeriesCaption(aChart: TChart; const aCaption: String);

  public
    { Public declarations }
    constructor Create(aOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

uses
  math;

{$R *.dfm}

constructor TForm1.Create(aOwner: TComponent);
begin
  inherited;
  srsCurrContribAlloc.FillSampleValues(5);
  srsCurrBalance.FillSampleValues(5);
end;

procedure TForm1.DrawPieSeriesCaption(aChart: TChart; const aCaption: String);
var
  lC: TCanvas3D;
  lR: TRect;
  lTop: Integer;
  lLeft: integer;
begin
  lR := aChart.ChartRect;

  lC := aChart.Canvas;
  lC.Font.Assign(aChart.Title.Font);
  lC.Brush.Style := bsClear;

  lTop := (lR.Top - lC.TextHeight('Ig')) div 2;

  lLeft := lR.Left + ((lR.Right-lR.Left - lC.TextWidth(aCaption)) div 2);
  lC.TextOut(lLeft, lTop, aCaption);
end;

function TForm1.GetChartHMargin(aChart: TChart): integer;
begin
  result := Min(aChart.Width div 20,aChart.Width div 20);
end;

function TForm1.GetChartVMargin(aChart: TChart): integer;
begin
  result := Min(aChart.Width div 10,aChart.Width div 10);
end;

procedure TForm1.srsCurrContribAllocBeforeDrawValues(Sender: TObject);
var
  lSrs: TPieSeries;
  lChart: TChart;
  lHMargin: Integer;
  lVMargin: Integer;
  lChartWidth: integer;
  lCaptionHeight: Integer;
  lCount: Integer;
begin
  lCount := ord(srsCurrContribAlloc.Visible) + ord(srsCurrBalance.Visible) +

    ord(srsRetireBalance.Visible);
  {$ifopt C+}
  assert(lCount in [1, 3]);
  {$endif}

  if lCount = 3 then
  begin
    // Pie #1

    Assert(Sender is TPieSeries);
    lSrs := TPieSeries(Sender);
    Assert(lSrs.ParentChart is TChart);
    lChart := TChart(lSrs.ParentChart);

    Assert(lSrs.Tag in [1,2,3]);


    lHMargin := GetChartHMargin(lChart);
    lVMargin := GetChartVMargin(lChart);

    lChartWidth := (lChart.Width - lHMargin) div 3;
    lHMargin := lHMargin div 4;
    lCaptionHeight := lChart.Canvas.TextHeight('T');

    lChart := TChart(lSrs.ParentChart);

    lChart.ChartRect := Rect(
      (lHMargin * lSrs.Tag) + (lCHartWidth * (lSrs.Tag-1)),
      lCaptionHeight + lVMargin,
      (lHMargin * lSrs.Tag) + (lChartWidth * lSrs.Tag),
      lChart.Height - (lVMargin div 2));

    DrawPieSeriesCaption(lChart, lSrs.Title);
  end;
end;

end.
